package com.sun.imageio.plugins.png;

class CRC
{
    private static int[] crcTable;
    private int crc;
    
    public CRC() {
        this.crc = -1;
    }
    
    public void reset() {
        this.crc = -1;
    }
    
    public void update(byte[] array, int n, int n2) {
        for (int i = 0; i < n2; ++i) {
            this.crc = (CRC.crcTable[(this.crc ^ array[n + i]) & 0xFF] ^ this.crc >>> 8);
        }
    }
    
    public void update(int n) {
        this.crc = (CRC.crcTable[(this.crc ^ n) & 0xFF] ^ this.crc >>> 8);
    }
    
    public int getValue() {
        return ~this.crc;
    }
    
    static {
        CRC.crcTable = new int[256];
        for (int i = 0; i < 256; ++i) {
            for (int i = i, j = 0; j < 8; CRC.crcTable[i] = i, ++j) {
                if ((i & 0x1) == 0x1) {
                    i = (0xEDB88320 ^ i >>> 1);
                }
                else {
                    i >>>= 1;
                }
            }
        }
    }
}
